import 'package:flutter/widgets.dart';
import 'package:flutter_dipnav/src/dip_nav_data.dart';

/// A class of configuration [PageRoute]
///
/// [guard] this callback should return true if navigation is permission
class DipNavRoute {
  final String? key;
  final String path;
  final Widget page;
  final DipNavData? data;
  final bool Function()? guard;

  DipNavRoute({
    this.key,
    required this.path,
    required this.page,
    Map<String, dynamic>? queries,
    Object? arguments,
    this.guard,
  }) : data = DipNavData(queries: queries, arguments: arguments);

  Uri get uri => Uri(path: path, queryParameters: data?.queries);
}
